]> git.pld-linux.org Git - packages/nfs-utils.git/blobdiff - nfs.init
- up to 1.2.8
[packages/nfs-utils.git] / nfs.init
index 91f3a0ec44d22eeecca8753243d7390b2b1a24ad..e3019b211b31db5f3cc89e443276b7085488b799 100644 (file)
--- a/nfs.init
+++ b/nfs.init
 #!/bin/sh
 #
-# nfs           This shell script takes care of starting and stopping
-#               the NFS services. Later we might add NIS too.
+# nfs          This shell script takes care of starting and stopping
+#              the NFS services.
 #
-# chkconfig:   345 60 20
+# chkconfig:   345 13 81
 # description: NFS is a popular protocol for file sharing across TCP/IP \
 #              networks. This service provides NFS server functionality, \
 #              which is configured via the /etc/exports file.
 # probe:       true
 
-
 # Source function library
 . /etc/rc.d/init.d/functions
 
 # Get network config
 . /etc/sysconfig/network
 
-# Get service config
-[ -f /etc/sysconfig/nfs ] && . /etc/sysconfig/nfs
+# Get service configs
+[ -f /etc/sysconfig/nfslock ] && . /etc/sysconfig/nfslock
+[ -f /etc/sysconfig/nfsd ] && . /etc/sysconfig/nfsd
 
 # Check that networking is up.
-[ "${NETWORKING}" = "no" ] && echo "Error: Networking is down" && exit 0
+if is_yes "${NETWORKING}"; then
+       if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
+               msg_network_down "NFS daemon"
+               exit 1
+       fi
+else
+       exit 0
+fi
+
+if [ "$1" != "stop" ]; then
+       check_portmapper || { nls "Error: portmap isn't running" && exit 0; }
+fi
+
+start() {
+       # Check if the service is already running?
+       if [ -f /var/lock/subsys/nfs ]; then
+               msg_already_running "NFS daemon"
+               return
+       fi
 
-# Sanity check
-[ -f /etc/exports ] || exit 0
+       if ! grep -q nfsd /proc/mounts ; then
+               modprobe -s nfsd > /dev/null 2>&1
+               run_cmd "Mounting /proc/fs/nfsd filesystem" mount -t nfsd nfsd /proc/fs/nfsd
+       fi
 
+       # Set the ports lockd should listen on
+       if [ -n "$LOCKD_TCPPORT" ]; then
+               /sbin/sysctl -w fs.nfs.nlm_tcpport=$LOCKD_TCPPORT >/dev/null 2>&1
+       fi
+       if [ -n "$LOCKD_UDPPORT" ]; then
+               /sbin/sysctl -w fs.nfs.nlm_udpport=$LOCKD_UDPPORT >/dev/null 2>&1
+       fi
 
+       # Start daemons.
+       msg_starting "NFS exportfs"
+       daemon /usr/sbin/exportfs -r
+       msg_starting "NFS mountd"
+       daemon /usr/sbin/rpc.mountd $RPCMOUNTDOPTIONS
+       msg_starting "NFS daemon"
+       daemon /usr/sbin/rpc.nfsd $RPCNFSDCOUNT
+       touch /var/lock/subsys/nfs
+}
+
+stop() {
+       if [ ! -f /var/lock/subsys/nfs ]; then
+               msg_not_running "NFS"
+               return
+       fi
+
+       # Stop daemons.
+       msg_stopping "NFS daemon"
+       killproc nfsd -QUIT
+       msg_stopping "NFS mountd"
+       killproc rpc.mountd
+       msg_stopping "NFS exportfs"
+       daemon /usr/sbin/exportfs -au
+       rm -f /var/lock/subsys/nfs
+}
+
+RETVAL=0
 # See how we were called.
 case "$1" in
   start)
-       # Check if the service is already running?
-       if [ ! -f /var/lock/subsys/nfs ]; then
-               show Starting rpc.mountd
-               daemon rpc.mountd
-               show Starting rpc.nfsd
-               daemon rpc.nfsd
+       start
+       ;;
+  stop)
+       stop
+       ;;
+  restart)
+       stop
+       start
+       /sbin/service idmapd status >/dev/null && /sbin/service idmapd reload
+       /sbin/service svcgssd status >/dev/null && /sbin/service svcgssd restart
+       ;;
+  reload|force-reload)
+       if [ -f /var/lock/subsys/nfs ]; then
+               msg_reloading "NFS"
+               busy
+               /usr/sbin/exportfs -r
+               [ $? -ne 0 ] && RETVAL=7
+               if [ $RETVAL -eq 0 ]; then
+                       ok
+                       /sbin/service idmapd status >/dev/null && /sbin/service idmapd reload
+                       /sbin/service svcgssd status >/dev/null && /sbin/service svcgssd restart
+               else
+                       died
+               fi
        else
-               echo "nfs already is running"
+               msg_not_running "NFS"
+               exit 7
        fi
-       touch /var/lock/subsys/nfs
        ;;
-  stop)
-       # Stop daemons.
-       show Shutting down rpc.mountd
-       killproc rpc.mountd
-       show Shutting down rpc.nfsd
-       killproc rpc.nfsd
-       rm -f /var/lock/subsys/nfs
+  probe)
+       if [ ! -f /var/lock/subsys/nfs ]; then
+               echo start
+               exit 0
+       fi
+       /sbin/pidof rpc.mountd >/dev/null 2>&1; MOUNTD="$?"
+       /sbin/pidof nfsd >/dev/null 2>&1; NFSD="$?"
+       if [ $MOUNTD = 1 -o $NFSD = 1 ]; then
+               echo restart
+               exit 0
+       fi
+       if [ /etc/exports -nt /var/lock/subsys/nfs ]; then
+               echo reload
+               exit 0
+       fi
        ;;
   status)
+       echo "Configured NFS exports:"
+       grep -v "^#" /etc/exports
+       echo
+       echo "Active NFS exports:"
+       /usr/sbin/exportfs -v
+       echo
        status rpc.mountd
-       status rpc.nfsd
-       ;;
-  restart)
-       $0 stop
-       $0 start
+       RETVAL=$?
+       status nfsd
+       RET=$?
+       [ $RETVAL -eq 0 ] && RETVAL=$RET
        ;;
   *)
-       echo "Usage: $0 {start|stop|status|restart}"
-       exit 1
+       msg_usage "$0 {start|stop|restart|reload|force-reload|probe|status}"
+       exit 3
 esac
 
-exit 0
-
+exit $RETVAL
This page took 0.039403 seconds and 4 git commands to generate.